def lunar_sum(a, b):
    a_str = str(a)
    b_str = str(b)
    max_len = max(len(a_str), len(b_str))
    a_padded = a_str.zfill(max_len)
    b_padded = b_str.zfill(max_len)
    result = ""
    for i in range(max_len):
        result += str(max(int(a_padded[i]), int(b_padded[i])))
    return int(result)

def lunar_product(a, b):
    a_str = str(a)
    b_str = str(b)
    min_len = min(len(a_str), len(b_str))
    max_len = max(len(a_str), len(b_str))
    minf=str(min(a, b))
    maxf=str(max(a, b))
    mas = [[0] * (max_len+min_len-1) for i in range(min_len)]
    result = ""
    a_padded = a_str.zfill(max_len)
    b_padded = b_str.zfill(max_len)
    k=max_len-1
    for i in range(max_len):
        result += str(min(int(a_padded[i]), int(b_padded[i])))
    return int(result)


a = int(input())
b = int(input())
print(lunar_sum(a, b), lunar_product(a, b))
