from collections import deque, defaultdict


def BFS(n, m, k, roads, guards):
    graph = defaultdict(list)

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)
    grd = set()
    for p, h in guards:
        queue = deque([(p, 0)])
        visited = set([p])
        while queue:
            curr, dist = queue.popleft()
            if dist <= h:
                grd.add(curr)
                for neighbor in graph[curr]:
                    if neighbor not in visited:
                        visited.add(neighbor)
                        queue.append((neighbor, dist + 1))
    grl = sorted(grd)
    return len(grl), grl
n, m, k = map(int, input().strip().split())
r = [tuple(map(int, input().strip().split())) for _ in range(m)]
g = [tuple(map(int, input().strip().split())) for _ in range(k)]
ans, gh = BFS(n, m, k, r, g)
print(ans)
if ans>0:
    print(" ".join(map(str, gh)))
